
#ifndef GBOT_H
#define GBOT_H
#include "SSocket.h"
#include "GObjList.h"

class GBoard;
class GBot
{
public:
	GBot(int nID, int nMaxWeight, int nMoney, GBoard* pBoard);
	virtual ~GBot();

	void Update(const char* sUpdates);
	virtual void PickedupPackage(int nPackage);
	virtual void DroppedPackage(int nPackage);
	virtual void OnMoved(char cCmd, int nValue){}

	void SetX(int nX) {m_nX=nX;}
	void SetY(int nY) {m_nY=nY;}

	int X() {return m_nX;}
	int Y() {return m_nY;}
	int ID() {return m_nID;}

	BOOL GetUpdated(){return m_bUpdated;}
	void SetUpdated(BOOL bUpdated){m_bUpdated=bUpdated;}
	
	
protected:
	int m_nX;
	int m_nY;
	int m_nID;
	int m_nScore;
	GBoard* m_pBoard;
	GObjList m_Packages;
	BOOL m_bUpdated;

	int m_nMaxWeight;
	int m_nCurWeight;
	int m_nMoney;
};
#endif