
#ifndef GOBJ_H
#define GOBJ_H
#include "SDefs.h"


class GObj
{
public:
	GObj(int nID, void* pData)
	{
		m_nID=nID;
		m_pData=pData;
		m_pNextObj=NULL;
		m_pPrevObj=NULL;
	}
	GObj* m_pNextObj;
	GObj* m_pPrevObj;
	void* m_pData;
	int m_nID;
};

class GObjList
{
public:
	GObjList();	
	void AddObj(int nID, void* pObj);
	void* FindObj(int nID);
	int Count(){return m_nCount;}
	void* RemoveObj(int nID);

	void* FirstObj();
	void* NextObj();
	
protected:
	GObj* m_pHead;
	GObj* m_pCur;
	GObj* m_pTail;
	int m_nCount;
};
#endif