
#ifndef GPATHCACHE_H
#define GPATHCACHE_H

#include "GObjList.h"
class GBoard; 
class GPath;

class GPathCache
{
public:
	GPathCache(GBoard* pBoard);
	GPath* FindPath(int nSX, int nSY, int nDX, int nDY);  // returns distance, 0 if no path found
	void ReleasePath(GPath* pPath);

protected:
	GBoard* m_pBoard;
	GObjList m_PathCache;
};

#endif