#ifndef SDEFS_H
#define SDEFS_H

#ifndef NULL
#define NULL (0l)// _SWISH_
#endif

#ifndef TRUE
#define TRUE (1)// _SWISH_
#endif

#ifndef FALSE
#define FALSE (0)// _SWISH_
#endif


typedef unsigned short WORD;// _SWISH_

#ifndef _WINDEF_
/*
	#ifndef TYPE_DWORD_DEF
		typedef unsigned long DWORD;
		#define TYPE_DWORD_DEF
	#endif*/

	#ifndef SWIG
	typedef  int BOOL;
	#endif

	typedef unsigned int UINT;
	typedef const char * LPCSTR;
	typedef char * LPSTR;

	// clipboard formats
	#define CF_TEXT             1
	#define CF_BITMAP           2
#endif

#ifdef MAX
	#undef MAX
	#undef MIN
#endif

typedef void * DLL;// _SWISH_

typedef unsigned int TextureHandle;

#define MAX(a, b)  (((a) > (b)) ? (a) : (b)) // _SWISH_
#define MIN(a, b)  (((a) < (b)) ? (a) : (b))  // _SWISH_

#ifndef TYPE_SOCKET_DEF
  typedef   unsigned int SOCKET;// _SWISH_
# define TYPE_SOCKET_DEF
#endif /* def type SOCKET */

#ifndef SWIG
typedef unsigned long PACKED_COLOR;
#endif

#define pcINVALID		(0xff000000)

#define pcBLACK			(0x000000)
#define pcDARKBLUE		(0x00007f)
#define pcDARKGREEN		(0x007f00)
#define pcDARKCYAN		(0x007f7f)
#define pcDARKRED		(0x7f0000)
#define pcDARKMAGENTA	(0x7f007f)
#define pcBROWN			(0x8b4513)
#define pcGREY			(0xc4c4c4)
#define pcDARKGREY		(0x7f7f7f)
#define pcBLUE			(0x0000ff)
#define pcGREEN			(0x00ff00)
#define pcCYAN			(0x00ffff)
#define pcRED			(0xff0000)
#define pcMAGENTA		(0xff00ff)
#define pcYELLOW		(0xffff00)
#define pcWHITE			(0xffffff)
#define pcGOLD			(0xfdce72)
#define pcBRIGHTGOLD	(0xfbf774)
#define pcORANGE        (0xff7f00)

#define PACK_COLOR(r,g,b) ( (((UINT)(r))<<16) | (((UINT)(g))<<8) | (UINT)(b) )
#define UNPACK_COLOR(c,r,g,b) ( ((r)=(BYTE)((c)>>16)&0xff),((g)=(BYTE)((c)>>8)&0xff),(b)=(BYTE)((c)&0xff) )

#define PACK_RGBA(r,g,b,a) ( (((UINT)(r))<<24) | (((UINT)(g))<<16) |(((UINT)(b))<<8) | (UINT)(a) )
#define UNPACK_RGBA(c,r,g,b,a) ( ((r)=(BYTE)((c)>>24)&0xff),((g)=(BYTE)((c)>>16)&0xff),((b)=(BYTE)((c)>>8)&0xff),(a)=(BYTE)((c)&0xff) )


// corners used by scripts and SFramedBox
#define TOP_LEFT		1// _SWISH_
#define TOP_RIGHT		2// _SWISH_
#define BOTTOM_LEFT	3// _SWISH_
#define BOTTOM_RIGHT 4// _SWISH_

// had enough reverse logic for one project...
#define streq(s1,s2) (!strcmp((s1),(s2)))
#define strieq(s1,s2) (!stricmp((s1),(s2)))

// system stuff
#if defined USE_ROGUE_EXPORT

#if defined(_MSC_VER)
#define ROGUE_EXPORT __declspec(dllexport)
#define ROGUE_IMPORT __declspec(dllimport)
#else
#define ROGUE_EXPORT
#define ROGUE_IMPORT
#endif

#else
#define ROGUE_EXPORT
#define ROGUE_IMPORT
#endif

#endif // SDEFS_H


