

#ifndef NULL
#define NULL (0l)// _SWISH_
#endif

#ifndef _WINDEF_
typedef int BOOL;
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
typedef unsigned char BYTE;
#endif





class SStringList
{
public:
	SStringList();	
	SStringList(const char* sString, char cSep, BOOL bTrimEnds=TRUE, BOOL bQuouted=FALSE);
	~SStringList();
	void Split(const char* sString, char cSep, BOOL bTrimEnds=TRUE, BOOL bQuouted=FALSE);

	const char* GetItem(int nItem);
	int GetItemAsInt(int nItem);	
	virtual const char* operator[] (int nIndex);

	int Count() { return m_nItemCnt; }
	int FindItem(const char* sItem);

		
protected:
	void InitVars();
	int CharCount(char cChar);
	int IndexList(char cSep, BOOL bTrimEnds, BOOL bQuouted);
	void TrimItems();

	char* m_sString;
	int* m_npIndex;

	int m_nItemCnt;
};