
#include "SSocket.h"
#include "GPath.h"
#include "main.h"

class GBoard;
class GPackage
{
public:
	GPackage(int nID, GBoard* pBoard)
	{
		m_nID=nID;
		m_pBoard=pBoard;
		m_nOnBot=-1;
		m_bPicked=FALSE;
	}

	~GPackage()
	{
	}

	void Init(int nX, int nY, int nDestX, int nDestY, int nWeight)
	{
		m_nX=nX;
		m_nY=nY;
		m_nDestX=nDestX;
		m_nDestY=nDestY;
		m_nWeight=nWeight;				
		m_pPath=g_PathCache.FindPath(m_nX, m_nY, m_nDestX, m_nDestY);
		m_nDistance=m_pPath->GetDistance();
	}

	int m_nID;
	int m_nWeight;
	int m_nX;
	int m_nY;
	int m_nDestX;
	int m_nDestY;
	int m_nDistance;
	BOOL m_nOnBot;
	BOOL m_bPicked; // package picked out for pickup
	GBoard* m_pBoard;
	GPath* m_pPath;
};